#include "app.h"
#include "frame_preview.h"
#include "frame_timeline.h"



namespace timeline {
void add_timeline1(const string& name, Timeline1 *tl)
{
	GetTimeline1Map().insert( pair<wxString, timeline1_ptr>(wxT(name.c_str()), timeline1_ptr(tl)) );
}

void add_timeline3(const string& name, Timeline3 *tl)
{
	GetTimeline3Map().insert( pair<wxString, timeline3_ptr>(wxT(name.c_str()), timeline3_ptr(tl)) );
}
} // namespace timeline

Timeline3& GetTimeline3()
{
	timeline3_map::iterator p = GetTimeline3Map().find( GetCurrentTimeline3Name() );
	if(p==GetTimeline3Map().end())
		throw runtime_error("GetTimeline3()");
	return *p->second;
}




IMPLEMENT_APP(HelloApp)

bool HelloApp::OnInit()
{
	current_frame = 0;


	tl_frame = new TimelineFrame(0);
	pr_frame = new PreviewFrame(tl_frame);

	pr_frame->Show(TRUE);
	tl_frame->Show(TRUE);

	SetTopWindow(tl_frame);

	return true;
}
