#ifndef TL_APP
#define TL_APP

#include <boost/shared_ptr.hpp>
#include <stdexcept>
#include <map>
#include <vector>
#include "wx/wxprec.h"
#include "wx/wx.h"
#include "wx/glcanvas.h"
#include "ist_math.h"
#include "ist_gl.h"
#include "timeline.h"

using namespace std;
using namespace boost;
using namespace ist;

typedef shared_ptr<Timeline1> timeline1_ptr;
typedef shared_ptr<Timeline3> timeline3_ptr;
typedef map<wxString, timeline1_ptr> timeline1_map;
typedef map<wxString, timeline3_ptr> timeline3_map;



class TimelineFrame;
class PreviewFrame;

class HelloApp : public wxApp
{
public:
	virtual bool OnInit();

	int current_frame;
	TimelineFrame *tl_frame;
	PreviewFrame *pr_frame;
	timeline1_map tl1_map;
	timeline3_map tl3_map;
	wxString current_tl3_name;
	gl::PolygonModel model;
	gl::Texture2D texture;
};

DECLARE_APP(HelloApp)
#define GetPreviewFrame() wxGetApp().pr_frame
#define GetTimelineFrame() wxGetApp().tl_frame
#define GetCurrentFrame() wxGetApp().current_frame
#define GetModel() wxGetApp().model
#define GetTexture() wxGetApp().texture
#define GetTimeline1Map() wxGetApp().tl1_map
#define GetTimeline3Map() wxGetApp().tl3_map
#define GetCurrentTimeline3Name() wxGetApp().current_tl3_name

Timeline3& GetTimeline3();


#endif
