#ifndef TL_TIMELINE
#define TL_TIMELINE

#include "app.h"


class TimelineCanvas;
class TimelineFrame : public wxFrame
{
public:
	TimelineFrame(wxWindow *parent);
	void OnPaint(wxPaintEvent& event);
	void OnLoadTimeline(wxCommandEvent& event);
	void OnSaveTimeline(wxCommandEvent& event);
	void OnTextChanged(wxScrollEvent& event);
	void OnSliderChanged(wxScrollEvent& event);
	void OnChoiceSelected(wxCommandEvent& event);
	void OnNewButton(wxCommandEvent& event);
	void OnCopyButton(wxCommandEvent& event);
	void OnDeleteButton(wxCommandEvent& event);
	void OnEditModeSelected(wxCommandEvent& event);


	void RefreshChoice();
	TimelineCanvas* GetCanvas() { return canvas; }
	wxSlider* GetTimelineSlider() { return timeline_slider; }
	wxRadioBox* GetModeSelector() { return mode_selector;  }

private:
	TimelineCanvas *canvas;
	wxTextCtrl *timeline_text;
	wxChoice *timeline_choice;
	wxSlider *timeline_slider;
	wxRadioBox *mode_selector;

	DECLARE_EVENT_TABLE()
};



#endif
