#ifndef GL_TEXTURE_INCLUDE
#define GL_TEXTURE_INCLUDE

#include <vector>


// gp̒:
// (܂̓Rs[RXgNg)Ƒ̃eNX`͖!
// R͏L̖̉̂߁c(std::auto_ptrƓl)



namespace ist {
namespace gl {


struct TextureDimension2D
{
	int dimension() const;
	void assign(unsigned int index) const;
	void setParameter(unsigned int *tex_name);
};


template<class Dimension>
struct TextureGeneratorRGBA : public Dimension
{ void generate(unsigned int *tex_name, int width, int height, unsigned char *pixel); };

template<class Dimension>
struct TextureGeneratorRGB : public Dimension
{ void generate(unsigned int *tex_name, int width, int height, unsigned char *pixel); };

template<class Dimension>
struct TextureGeneratorAlpha : public Dimension
{ void generate(unsigned int *tex_name, int width, int height, unsigned char *pixel); };




class TextureBase
{
public:
	virtual ~TextureBase() {}
	virtual bool load(const char *filename)=0;
	virtual bool load(const char *filename, unsigned int cell_width, unsigned int cell_height)=0;
	virtual void clear()=0;
	virtual void assign(unsigned int index=0) const =0;
	virtual unsigned int numCell() const =0;
};


template<class Generator>
class TTexture : public TextureBase
{
public:
	TTexture();
	TTexture(const char *filename);
	TTexture(const char *filename, unsigned int cell_width, unsigned int cell_height);
	~TTexture();

	TTexture(const TTexture&);
	TTexture& operator =(const TTexture&);

	bool load(const char *filename);
	bool load(const char *filename, unsigned int cell_width, unsigned int cell_height);
	void clear();
	void assign(unsigned int index=0) const;
	unsigned int numCell() const { return tex_name.size(); }

private:
	Generator generator;
	std::vector<unsigned int> tex_name;
};


typedef TTexture< TextureGeneratorRGBA<TextureDimension2D> >  Texture2D;
typedef TTexture< TextureGeneratorRGB<TextureDimension2D> >   Texture2DRGB;
typedef TTexture< TextureGeneratorAlpha<TextureDimension2D> > Texture2DAlpha;

}	// gl
}	// ist

#endif


